# Helloworld plugin

from trac.core import *
from trac.web.chrome import add_stylesheet, INavigationContributor, ITemplateProvider
from trac.web.main import IRequestHandler
from trac.util import escape

class UserbaseModule(Component):
	implements(INavigationContributor, IRequestHandler, ITemplateProvider)
	
	# INavigationContributor methods
	def get_active_navigation_item(self, req):
		return 'helloworld'
		
	def get_navigation_items(self, req):
		yield 'mainnav', 'helloworld', '<a href="%s">Hello</a>' \
				  % escape(self.env.href.helloworld())
	
	# IRequestHandler methods
	def match_request(self, req):
		return req.path_info == '/helloworld'
					
	def process_request(self, req):
		add_stylesheet(req, 'css/helloworld.css')
		return 'helloworld.cs', None
		
	# ITemplateProvider methods
	def get_templates_dir(self):
		"""
		Return the absolute path of the directory containing the provided
		ClearSilver templates.
		"""
		from pkg_resources import resource_filename
		return resource_filename(__name__, 'templates')

	def get_htdocs_dir(self):
		"""
		Return the absolute path of a directory containing additional
		static resources (such as images, style sheets, etc).
		"""
		from pkg_resources import resource_filename
		return resource_filename(__name__, 'htdocs')
		
